<?php
/**
 * DBShop 电子商务系统
 *
 * ==========================================================================
 * @link      http://www.dbshop.net/
 * @copyright Copyright (c) 2012-2015 DBShop.net Inc. (http://www.dbshop.net)
 * @license   http://www.dbshop.net/license.html License
 * ==========================================================================
 *
 * @author    静静的风
 *
 */
namespace Email\Common\Service;

class SendPhoneSms
{
    private $smsConfig = array();

    public function __construct()
    {
        //获取email的配置信息
        if(empty($this->smsConfig)) {
            $readerConfig        = new \Zend\Config\Reader\Ini();
            $this->smsConfig   = $readerConfig->fromFile(DBSHOP_PATH . '/data/moduledata/System/phonesms.ini');
        }

    }
    /**
     * 阿里大于发送手机短信
     * @param $data
     * @param $user_phone
     * @param string $phone_template
     * @param string $user_id
     * @return bool
     */
    public function toSendSms($data, $user_phone, $phone_template='', $user_id = '') {

       
        // //判断是否存在
        // if(!isset($this->smsConfig['shop_phone_sms']['phone_sms_type']) or !isset($this->smsConfig['shop_phone_sms'][$phone_template])) return false;



        // //判断是否开启了手机短信服务功能，如果未开启则不进行操作

        // if($this->smsConfig['shop_phone_sms']['phone_sms_type'] == '' or $this->smsConfig['shop_phone_sms'][$phone_template] == '') return false;


        //判断是否存在,手机是否开启了短信服务功能，如果不存在未开启则不进行操作

        if (!isset($this->smsConfig['shop_phone_sms']['phone_sms_type']) or $this->smsConfig['shop_phone_sms']['phone_sms_type'] == '') return false;
       


        $user_phone = !empty($user_phone) ? (is_array($user_phone) ? implode(',', $user_phone) : $user_phone) : '';





        if ($this->smsConfig['shop_phone_sms']['phone_sms_type'] == 'smsbao') {

             if(!isset($this->smsConfig['shop_phone_sms'][$phone_template['smsbao']]) or $this->smsConfig['shop_phone_sms'][$phone_template['smsbao']] == '') return false;

            if(!empty($this->smsConfig['shop_phone_sms']['admin_phone'])) {
            if($phone_template['smsbao'] == 'smsbao_submit_order_template_id' && $this->smsConfig['shop_phone_sms']['admin_submit_order_phone_message'] == 1)    $user_phone = !empty($user_phone) ? $user_phone.','.$this->smsConfig['shop_phone_sms']['admin_phone'] : $this->smsConfig['shop_phone_sms']['admin_phone'];
            if($phone_template['smsbao'] == 'smsbao_payment_order_template_id' && $this->smsConfig['shop_phone_sms']['admin_payment_order_phone_message'] == 1)  $user_phone = !empty($user_phone) ? $user_phone.','.$this->smsConfig['shop_phone_sms']['admin_phone'] : $this->smsConfig['shop_phone_sms']['admin_phone'];

            if($phone_template['smsbao'] == 'smsbao_ship_order_template_id' && $this->smsConfig['shop_phone_sms']['admin_ship_order_phone_message'] == 1)  $user_phone = !empty($user_phone) ? $user_phone.','.$this->smsConfig['shop_phone_sms']['admin_phone'] : $this->smsConfig['shop_phone_sms']['admin_phone'];
            if($phone_template['smsbao'] == 'smsbao_finish_order_template_id' && $this->smsConfig['shop_phone_sms']['admin_finish_order_phone_message'] == 1)    $user_phone = !empty($user_phone) ? $user_phone.','.$this->smsConfig['shop_phone_sms']['admin_phone'] : $this->smsConfig['shop_phone_sms']['admin_phone'];
            if($phone_template['smsbao'] == 'smsbao_cancel_order_template_id' && $this->smsConfig['shop_phone_sms']['admin_cancel_order_phone_message'] == 1)    $user_phone = !empty($user_phone) ? $user_phone.','.$this->smsConfig['shop_phone_sms']['admin_phone'] : $this->smsConfig['shop_phone_sms']['admin_phone'];
        }

             if(empty($user_phone)) return false;
              $user_phone = is_array($user_phone) ? implode(',', $user_phone) : $user_phone;

             $smsJson    = $this->createSmsbaoArray($data);

             // var_dump($this->smsConfig['shop_phone_sms'][$phone_template['smsbao']]);exit;

             $tempdata = $this->smsConfig['shop_phone_sms'][$phone_template['smsbao']];
            foreach ($smsJson as $key => $value ) 
                {   
                    $tempdata = str_replace(trim($key), trim($value), $tempdata);
                };

                $content = $tempdata;

                $content = "【".$this->smsConfig['shop_phone_sms']['smsbao_sign_name']."】".$tempdata;

            $result = array(
                "30"=>"密码错误",
                "40"=>"账号不存在",
                "41"=>"余额不足",
                "42"=>"帐号过期",
                "43"=>"IP地址限制",
                "50"=>"内容含有敏感词",
                "51"=>"手机号码不正确"
                );

              

             $url = 'http://api.smsbao.com/sms?u='.$this->smsConfig['shop_phone_sms']['smsbao_app_key'].'&p='.md5($this->smsConfig['shop_phone_sms']['smsbao_app_secret']).'&m='.$user_phone.'&c='.$content;


             $ret = file_get_contents($url);

             if ($ret == 0) {
                 return true;
             }else{
                return $result[$ret];
             }
        }else{

            if(!isset($this->smsConfig['shop_phone_sms'][$phone_template['alidayu']]) or $this->smsConfig['shop_phone_sms'][$phone_template['alidayu']] == '') return false;

            if(!empty($this->smsConfig['shop_phone_sms']['admin_phone'])) {
                if($phone_template['alidayu'] == 'alidayu_submit_order_template_id' && $this->smsConfig['shop_phone_sms']['admin_submit_order_phone_message'] == 1)    $user_phone = !empty($user_phone) ? $user_phone.','.$this->smsConfig['shop_phone_sms']['admin_phone'] : $this->smsConfig['shop_phone_sms']['admin_phone'];
                if($phone_template['alidayu'] == 'alidayu_payment_order_template_id' && $this->smsConfig['shop_phone_sms']['admin_payment_order_phone_message'] == 1)  $user_phone = !empty($user_phone) ? $user_phone.','.$this->smsConfig['shop_phone_sms']['admin_phone'] : $this->smsConfig['shop_phone_sms']['admin_phone'];

                if($phone_template['alidayu'] == 'alidayu_ship_order_template_id' && $this->smsConfig['shop_phone_sms']['admin_ship_order_phone_message'] == 1)  $user_phone = !empty($user_phone) ? $user_phone.','.$this->smsConfig['shop_phone_sms']['admin_phone'] : $this->smsConfig['shop_phone_sms']['admin_phone'];
                if($phone_template['alidayu'] == 'alidayu_finish_order_template_id' && $this->smsConfig['shop_phone_sms']['admin_finish_order_phone_message'] == 1)    $user_phone = !empty($user_phone) ? $user_phone.','.$this->smsConfig['shop_phone_sms']['admin_phone'] : $this->smsConfig['shop_phone_sms']['admin_phone'];
                if($phone_template['alidayu'] == 'alidayu_cancel_order_template_id' && $this->smsConfig['shop_phone_sms']['admin_cancel_order_phone_message'] == 1)    $user_phone = !empty($user_phone) ? $user_phone.','.$this->smsConfig['shop_phone_sms']['admin_phone'] : $this->smsConfig['shop_phone_sms']['admin_phone'];
            }
            if(empty($user_phone)) return false;

            $smsJson    = $this->createSmsArray($data);
            //$user_phone = is_array($user_phone) ? implode(',', $user_phone) : $user_phone;

            include(DBSHOP_PATH . '/vendor/alibaba/dayu/TopSdk.php');
            $c = new \TopClient();
            $c->appkey    = $this->smsConfig['shop_phone_sms']['alidayu_app_key'];
            $c->secretKey = $this->smsConfig['shop_phone_sms']['alidayu_app_secret'];

            $req = new \AlibabaAliqinFcSmsNumSendRequest();
            $req->setExtend($user_id);
            $req->setSmsType('normal');
            $req->setSmsFreeSignName($this->smsConfig['shop_phone_sms']['alidayu_sign_name']);
            $req->setSmsParam($smsJson);
            $req->setRecNum($user_phone);
            $req->setSmsTemplateCode($this->smsConfig['shop_phone_sms'][$phone_template]);
            $resp = $c->execute($req);

        }



    }

    /**
     * 对内容进行json处理
     * @param $data
     * @return string
     */
    private function createSmsArray($data) {
        $bodyArray  = array(
            'shopname'   => (isset($data['shopname'])     ? $data['shopname']     : ''),
            'buyname'    => (isset($data['buyname'])      ? $data['buyname']      : ''),
            'ordersn'    => (isset($data['ordersn'])      ? $data['ordersn']      : ''),
            'ordertotal' => (isset($data['ordertotal'])      ? $data['ordertotal']      : ''),
            'expressname'=> (isset($data['expressname'])      ? $data['expressname']      : ''),
            'expressnumber' => (isset($data['expressnumber'])      ? $data['expressnumber']      : ''),

            'code'      => (isset($data['captcha'])         ? $data['captcha']              : ''),
            'product'   => (isset($data['patcheashopname']) ? $data['patcheashopname']      : ''),
        );
        return json_encode($bodyArray);
    }

    private function createSmsbaoArray($data) {
        $bodyArray  = array(
            'shopname'   => (isset($data['shopname'])     ? $data['shopname']     : ''),
            'buyname'    => (isset($data['buyname'])      ? $data['buyname']      : ''),
            'ordersn'    => (isset($data['ordersn'])      ? $data['ordersn']      : ''),
            'ordertotal' => (isset($data['ordertotal'])      ? $data['ordertotal']      : ''),
            'expressname'=> (isset($data['expressname'])      ? $data['expressname']      : ''),
            'expressnumber' => (isset($data['expressnumber'])      ? $data['expressnumber']      : ''),

            'code'      => (isset($data['captcha'])         ? $data['captcha']              : ''),
            'product'   => (isset($data['patcheashopname']) ? $data['patcheashopname']      : ''),
        );
        return $bodyArray;
    }
}